Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class InheritableThreadLocal

    java.lang.Object
      |
      +--java.lang.ThreadLocal
            |
            +--java.lang.InheritableThreadLocal

public class InheritableThreadLocal
extends ThreadLocal

This class extends ThreadLocal to provide inheritance of values from parent Thread to child Thread: when a child thread is created, the child receives initial values for all InheritableThreadLocals for which the parent has values. Normally the child's values will be identical to the parent's; however, the child's value can be made an arbitrary function of the parent's by overriding the childValue method in this class.

InheritableThreadLocal variables are used in preference to ordinary ThreadLocal variables when the per-thread-attribute being maintained in the variable (e.g., User ID, Transaction ID) must be automatically transmitted to any child threads that are created.

Since:
  1.2
See Also:
  `ThreadLocal`

Constructor Summary
`InheritableThreadLocal()` Creates an InheritableThreadLocal variable.

Method Summary
`protected Object` | `childValue(Object parentValue)` Computes the child's initial value for this InheritableThreadLocal as a function of the parent's value at the time the child Thread is created.
`Object` | `get()` Returns the value in the calling thread's copy of this ThreadLocal variable.
`void` | `set(Object value)` Sets the calling thread's instance of this ThreadLocal variable to the given value.

Methods inherited from class java.lang.ThreadLocal
`initialValue`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InheritableThreadLocal

    public InheritableThreadLocal()

  Creates an InheritableThreadLocal variable.

Method Detail

### get

    public Object get()

  Returns the value in the calling thread's copy of this ThreadLocal variable. Creates and initializes the copy if this is the first time the thread has called this method.
  Overrides:
    `get` in class `ThreadLocal`
  Following copied from class: `java.lang.ThreadLocal`
  Returns:
    the value of this ThreadLocal

### set

    public void set(Object value)

  Sets the calling thread's instance of this ThreadLocal variable to the given value. This is only used to change the value from the one assigned by the initialValue method, and many applications will have no need for this functionality.
  Overrides:
    `set` in class `ThreadLocal`
  Parameters:
    `value` - the value to be stored in the calling threads' copy of this ThreadLocal.

### childValue

    protected Object childValue(Object parentValue)

  Computes the child's initial value for this InheritableThreadLocal as a function of the parent's value at the time the child Thread is created. This method is called from within the parent thread before the child is started.

  This method merely returns its input argument, and should be overridden if a different behavior is desired.

  Parameters:
    `parentValue` - the parent thread's value
  Returns:
    the child thread's initial value

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.